#ifndef INC_GTFILEREQ_H
#define INC_GTFILEREQ_H

#include "gtwidget.h"
#include "gtgroup.h"
#include "gtscrlist.h"
#include "gtstrinput.h"
#include "gtbutton.h"
#include "gtcblist.h"

/************************************************************************\
*
* GtFileReq class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

/* Type of filereq callback data */
typedef struct GtFileReqCD
{
	char *file;
	sbool ok;
} GtFileReqCD;


class GtFileReq : public GtWidget
{
public:
		/* Standard */
	GtFileReq(void);
	void Destroy(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	char *GetClass(void) { return("GtFileReq"); }
	sbool IsSubClassOf(char *cn);
		/* Instance checks */
	sbool Manage(void) { return(FALSE); }
		/* Values */
	GtGroup *GetGroup(void) { return(grp); }
	GtGroup *GetButtonGroup(void) { return(bgrp); }
	GtStrInput *GetPattern(void) { return(pat); }
	GtStrInput *GetFile(void) { return(file); }
	char *GetPatternStr(void) { return(pat->GetString()); }
	char *GetFileStr(void) { return(file->GetString()); }
	void SetPattern(char *p);
	void SetDir(char *d);
	void SetFile(char *f);
		/* Callbacks */
	void AddCB(ulong tag,GtCallB cb,GtUDPtr ud);
	void RemCB(ulong tag,GtCallB cb);
		/* Activate filerequester */
	void Activate(void);
	void Deactivate(void);
private:
	static int ListSelect(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
	static int PatternDone(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
	static int FileDone(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
	static int LoadSave(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
	static int Cancel(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
	void ScanDir(void);
protected:
		/* Instance variables */
	GtCBList done;
	GtGroup *grp,*bgrp;
	GtButton *load,*save;
	GtScrList *sl;
	GtStrInput *pat,*file;
	int home,curr;
};

extern GtFileReq *GtMkFileReq(char *n,GtManager *p,GtTag *tgs);
extern GtFileReq *GtMkFileReq(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTFILEREQ_H */
